import BetterSqlite3Database from "better-sqlite3";
export interface Query {
    source: string;
    parameters: any[];
}
export declare function sql(template: TemplateStringsArray, ...substitutions: any[]): Query;
export interface Options {
    safeIntegers?: boolean;
}
export declare class Database extends BetterSqlite3Database {
    statements: Map<string, BetterSqlite3Database.Statement>;
    run(query: Query, options?: Options): BetterSqlite3Database.RunResult;
    get<T>(query: Query, options?: Options): T | undefined;
    all<T>(query: Query, options?: Options): T[];
    iterate<T>(query: Query, options?: Options): IterableIterator<T>;
    execute(query: Query): this;
    executeTransaction<T>(fn: () => T): T;
    executeTransactionImmediate<T>(fn: () => T): T;
    executeTransactionExclusive<T>(fn: () => T): T;
    migrate(...migrations: (Query | ((database: this) => void))[]): void;
    getStatement(source: string, options?: Options): BetterSqlite3Database.Statement;
}
//# sourceMappingURL=index.d.ts.map